import sys, traceback

#observer pattern
class Observer:
    def __init__(self):
        pass
    def update(self, theChangedSubject):
        pass

class Subject:
    def __init__(self):
        self.observerList = []
    def attach(self, observer):
        self.observerList.append(observer)
    def detach(self, observer):
        try:
            self.observerList.remove(observer)
        except ValueError: #ignore if x not in list
            pass
    def notify(self, *args):
        for observer in self.observerList:
            try:
                observer.update(self, *args)
            except Exception:
                print "Subject.notify() exception in update():"
                traceback.print_exc(file=sys.stdout)

class Tee:
    def __init__(self, files):
        self.files = files
    def write(self, s):
        for m in self.files:
            m.write(s)
    def flush(self):
        for m in self.files:
            m.flush()
