import shelve
import logging
import os

log = logging.getLogger('persistence')

class LoggingDbfilenameShelf(shelve.DbfilenameShelf):
    """shelve, but with logging when the file is read or written"""
    def __init__(self, filename):
        log.info('Loading persistent data from "%s"' % os.path.abspath(filename))
        shelve.DbfilenameShelf.__init__(self, filename)
        
    def sync(self, *args, **kwargs):
        log.info('Syncing persistent data')
        shelve.DbfilenameShelf.sync(self, *args, **kwargs)

# - - - Plugin Interface - - -
depends = ['system']
provides = ['persistent']

def init(manager):
    manager['persistent'] = LoggingDbfilenameShelf(manager['system.persistent.filename'])

def stop(manager):
    manager['persistent'].sync()

def destroy(manager):
    manager['persistent'].close()