#from modules import logger

#logger.init('logger_config.ini')
#log = logger.logging.getLogger('filterinterface')
class DataPoint:
    def __init__(self, source, time, value):
        self.source = source
        self.time = time
        self.value = value

class Processor(object):
    input_channels = []
    output_channels = []
    name = ''
    description = ''
    config = None

    def __init__(self, id, settings): 
        self.input = {}
        self.output = {}
        self.settings = settings
        self.parents = []
        self.id = id

    def AddOutputChannel(self, channel):
        self.output[channel] = []

    def initialize(self):
        try:
            for x in self.output_channels:
                self.AddOutputChannel(x)
        except NameError:
            pass

    def AddInputChannel(self, channel, handler):
        self.input[channel] = handler

    # Defined to make sure we don't get a crash
    def setParameters(self, **kwargs):
        pass
        
    def appendChild(self, channel, child):
        if child.im_self:
            child.im_self.parents.append((self, channel, child))
        if self.output.has_key(channel):
            self.output[channel].append(child)
        else:
            raise NameError, "No such channel"

    def removeChild(self, channel, child):
        if self.output.has_key(channel) and child in self.output[channel]:
            self.output[channel].remove(child)
        else:
            print 'Failed to remove child'

    def passTo(self, channel, dataPoint):
        for x in self.output[channel]:
            dataPoint.source = self.id + '.' + channel
            x(dataPoint)

    def connectTo(self, i_channel, instance, o_channel):
        instance.appendChild(o_channel, self.input[i_channel])

class Interface:
    def __init__(self, inst):
        def initilaizer(self, id, dict):
            Processor.__init__(self, id, dict)
            try:
                inst.__init__(self, dict)
            except NameError:
                pass
                #log.warning('WARNING: Plugin %s does not implement __init__' % name)
        
        self.inst = type(inst.__name__, (inst, Processor, object,), {'__init__' : initilaizer})
    def __getitem__(self, point):
        if point=='name':
            return self.inst.name
        elif point=='description':
            return self.inst.description
        elif point=='inst':
            return self.getInstance
        elif point=='settings':
            return self.inst.settings
        elif point == 'output_channels':
            return self.inst.output_channels
        elif point == 'input_channels':
            return self.inst.input_channels

    def getInstance(self, id, dict):
        return  self.inst(id, dict)

#### Plugin Interface ####

depend = []
provides = ['nogui.interface', 'nogui.datapoint']
    
def init(manager):
    manager['nogui.interface'] = Interface
    manager['nogui.datapoint'] = DataPoint
