from twisted.internet.protocol import DatagramProtocol
from twisted.internet import reactor
import logging
log = logging.getLogger('autofinder')

manager = None

class Autofinder(DatagramProtocol):
    def datagramReceived(self, data, (host, port)):
        log.debug("Autofinder received %r from %s:%d" % (data, host, port))
        self.transport.write(data, (host, port))

#### Plugin interface ####

depend = []
provides = ['server.autofinder']

def init(pmanager):
    finder = Autofinder()
    global manager; manager = pmanager
    pmanager['server.autofinder'] = finder
    reactor.listenUDP(40001, finder)
