import ConfigParser, socket, traceback

class Core:
    def __init__(self):
        self.sources = {}
        self.limitedMode = True
        self.ReadSrcConfig()

    def ReadSrcConfig(self):
        try:
            parser = ConfigParser.ConfigParser()
            parser.read('source_config.ini')
            for section in parser.sections():
                settings = {}
                for option in parser.options(section):
                    if option != 'type':
                       settings[option] = parser.get(section, option)
            
                self.sources[section] = manager[parser.get(section, 'type') + '.inst'](section, settings)

            # We have created the sources. Now try initializing them
            map(lambda x: self.sources[x].initialize(), self.sources.keys())
            self.limitedMode = False
            return True

        except Exception, e:
            traceback.print_exc(file=sys.stdout)
            self.limitedMode = True
            return False

    def ListSources(self):
        result = {}
        for x in self.sources.keys():
            result[x] = [self.sources[x].name, self.sources[x].description, 
                self.sources[x].output_channels, self.sources[x].settings]
        return result

    def ListFilters(self):
        result = {}
        # Godamn - I love functional programming :-)
        filters_list = [ x for x in reduce(lambda x,y: x+y, 
                [x.provides for x in manager.plugins]) if x.startswith('filters') ]
                
        for x in filters_list:
            result[x] = [ manager[x+'.description'], manager[x + '.input_channels'], 
                manager[x + '.output_channels'], manager[x + '.settings']]

        return result

    def name(self):
        """return the name of this server"""
        return socket.getfqdn(socket.gethostname())


#### Plugin Interface #####

depends = []
provides  = ['server.core']

def init(pluginmanager):
    global manager; manager = pluginmanager
    
    manager['server.core'] = Core()
