from twisted.internet import defer
from twisted.cred import checkers, credentials

class SessionDatabase:

    credentialInterfaces = (credentials.IUsernamePassword,
        credentials.IUsernameHashedPassword)

    def __init__(self, **users):
        self.users = users

    def addUser(self, username, password):
        self.users[username] = password

    def _cbPasswordMatch(self, matched, username):
        if matched:
            return username
        else:
            return failure.Failure(error.UnauthorizedLogin())

    def requestAvatarId(self, credentials):
        if not credentials.username == 'admin':
            return credentials.username
        else:
            return defer.maybeDeferred(
                credentials.checkPassword,
                self.users[credentials.username]).addCallback(
                self._cbPasswordMatch, credentials.username)


#### Plugin interface

provides = ['server.checker']
depends = []

def init(manager):
    manager['server.checker'] = SessionDatabase
