from twisted.internet import reactor
import math, time

sourcename = "sources.sinus"
sourcedescription = "Simple Sinus-wave generator"
sourcesettings = {
    'interval':['Pulse-Interval', 'float', 0, 2]
}

DataPoint = None

class TestSource(object):
    output_channels = ['out']
    input_channels = []
    name=sourcename
    description = sourcedescription
    settings = sourcesettings
    
    def __init__(self, dict):
        self.time = 0.0
        self.base = time.time()

        interval = float(dict.get('interval', 0.1))
        if interval < 0 or interval > 2:
            raise NameError, 'Invalid interval value: %s' % str(interval)

    def initialize(self):
        map(self.AddOutputChannel, self.output_channels)
        self.setParameters(self.settings)
        reactor.callLater(self.interval, self.nextValue)

    #def appendChild(self, proc):
    #   reactor.callLater(self.interval, self.nextValue)
    #   super(TestSource, self).appendChild(proc)

    def setParameters(self, dict):
        self.interval = float(dict.get('interval', 0.1))
        
    def nextValue(self):
        self.time += 0.1
        value = math.sin(self.time)
        self.passTo('out', DataPoint(self.name, time.time() - self.base, value))
        reactor.callLater(self.interval, self.nextValue)

##### Plugin interface #####
depends = ['nogui.interface', 'nogui.datapoint']
provides = [sourcename]

def init(manager):
    manager[sourcename] = manager['nogui.interface'](TestSource)
    global DataPoint
    DataPoint = manager['nogui.datapoint']
